#ifndef _H_C3FC8CC17FE3A4F7BC8CDAD6463228BB_ChangeMode__H_
#define _H_C3FC8CC17FE3A4F7BC8CDAD6463228BB_ChangeMode__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace system_modes
{
    namespace srv
    {
        namespace dds_
        {
            struct  ChangeMode_Request_
            {
                ::DDS::String_mgr node_name_;
                ::DDS::String_mgr mode_name_;
            };

            typedef DDS_DCPSStruct_var<ChangeMode_Request_> ChangeMode_Request__var;
            typedef DDS_DCPSStruct_out < ChangeMode_Request_> ChangeMode_Request__out;

            struct  ChangeMode_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<ChangeMode_Response_> ChangeMode_Response__var;
            typedef ChangeMode_Response_& ChangeMode_Response__out;

            struct  Sample_ChangeMode_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::ChangeMode_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ChangeMode_Request_> Sample_ChangeMode_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ChangeMode_Request_> Sample_ChangeMode_Request__out;

            struct  Sample_ChangeMode_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::ChangeMode_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ChangeMode_Response_> Sample_ChangeMode_Response__var;
            typedef Sample_ChangeMode_Response_& Sample_ChangeMode_Response__out;

        }

    }

}

#endif /* _H_C3FC8CC17FE3A4F7BC8CDAD6463228BB_ChangeMode__H_ */
