#ifndef _H_17BA2B46D6A9DDC6DC3AFEBED097DDDB_GetAvailableModes__H_
#define _H_17BA2B46D6A9DDC6DC3AFEBED097DDDB_GetAvailableModes__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace system_modes
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetAvailableModes_Request_
            {
                ::DDS::String_mgr node_name_;
            };

            typedef DDS_DCPSStruct_var<GetAvailableModes_Request_> GetAvailableModes_Request__var;
            typedef DDS_DCPSStruct_out < GetAvailableModes_Request_> GetAvailableModes_Request__out;

            struct  GetAvailableModes_Response_
            {
                struct _available_modes__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _available_modes__seq_uniq_ > _available_modes__seq;
                typedef DDS_DCPSUStrSeq_var< _available_modes__seq > _available_modes__seq_var;
                typedef DDS_DCPSUStrSeq_out< _available_modes__seq > _available_modes__seq_out;
                _available_modes__seq available_modes_;
            };

            typedef DDS_DCPSStruct_var<GetAvailableModes_Response_> GetAvailableModes_Response__var;
            typedef DDS_DCPSStruct_out < GetAvailableModes_Response_> GetAvailableModes_Response__out;

            struct  Sample_GetAvailableModes_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::GetAvailableModes_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetAvailableModes_Request_> Sample_GetAvailableModes_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetAvailableModes_Request_> Sample_GetAvailableModes_Request__out;

            struct  Sample_GetAvailableModes_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::GetAvailableModes_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetAvailableModes_Response_> Sample_GetAvailableModes_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetAvailableModes_Response_> Sample_GetAvailableModes_Response__out;

        }

    }

}

#endif /* _H_17BA2B46D6A9DDC6DC3AFEBED097DDDB_GetAvailableModes__H_ */
