#ifndef _H_D212F36D29C637C28F81C1E2F0EC94EB_GetMode__H_
#define _H_D212F36D29C637C28F81C1E2F0EC94EB_GetMode__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace system_modes
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetMode_Request_
            {
                ::DDS::String_mgr node_name_;
            };

            typedef DDS_DCPSStruct_var<GetMode_Request_> GetMode_Request__var;
            typedef DDS_DCPSStruct_out < GetMode_Request_> GetMode_Request__out;

            struct  GetMode_Response_
            {
                ::DDS::String_mgr current_mode_;
            };

            typedef DDS_DCPSStruct_var<GetMode_Response_> GetMode_Response__var;
            typedef DDS_DCPSStruct_out < GetMode_Response_> GetMode_Response__out;

            struct  Sample_GetMode_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::GetMode_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetMode_Request_> Sample_GetMode_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetMode_Request_> Sample_GetMode_Request__out;

            struct  Sample_GetMode_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::system_modes::srv::dds_::GetMode_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetMode_Response_> Sample_GetMode_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetMode_Response_> Sample_GetMode_Response__out;

        }

    }

}

#endif /* _H_D212F36D29C637C28F81C1E2F0EC94EB_GetMode__H_ */
