// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from system_modes:srv/GetMode.idl
// generated code does not contain a copyright notice

#ifndef SYSTEM_MODES__SRV__GET_MODE__STRUCT_HPP_
#define SYSTEM_MODES__SRV__GET_MODE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__system_modes__srv__GetMode_Request __attribute__((deprecated))
#else
# define DEPRECATED__system_modes__srv__GetMode_Request __declspec(deprecated)
#endif

namespace system_modes
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMode_Request_
{
  using Type = GetMode_Request_<ContainerAllocator>;

  explicit GetMode_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->node_name = "";
    }
  }

  explicit GetMode_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : node_name(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->node_name = "";
    }
  }

  // field types and members
  using _node_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _node_name_type node_name;

  // setters for named parameter idiom
  Type & set__node_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->node_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    system_modes::srv::GetMode_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes::srv::GetMode_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes::srv::GetMode_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes::srv::GetMode_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes__srv__GetMode_Request
    std::shared_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes__srv__GetMode_Request
    std::shared_ptr<system_modes::srv::GetMode_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMode_Request_ & other) const
  {
    if (this->node_name != other.node_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMode_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMode_Request_

// alias to use template instance with default allocator
using GetMode_Request =
  system_modes::srv::GetMode_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace system_modes


#ifndef _WIN32
# define DEPRECATED__system_modes__srv__GetMode_Response __attribute__((deprecated))
#else
# define DEPRECATED__system_modes__srv__GetMode_Response __declspec(deprecated)
#endif

namespace system_modes
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMode_Response_
{
  using Type = GetMode_Response_<ContainerAllocator>;

  explicit GetMode_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_mode = "";
    }
  }

  explicit GetMode_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : current_mode(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->current_mode = "";
    }
  }

  // field types and members
  using _current_mode_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _current_mode_type current_mode;

  // setters for named parameter idiom
  Type & set__current_mode(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->current_mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    system_modes::srv::GetMode_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const system_modes::srv::GetMode_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      system_modes::srv::GetMode_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      system_modes::srv::GetMode_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__system_modes__srv__GetMode_Response
    std::shared_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__system_modes__srv__GetMode_Response
    std::shared_ptr<system_modes::srv::GetMode_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMode_Response_ & other) const
  {
    if (this->current_mode != other.current_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMode_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMode_Response_

// alias to use template instance with default allocator
using GetMode_Response =
  system_modes::srv::GetMode_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace system_modes

namespace system_modes
{

namespace srv
{

struct GetMode
{
  using Request = system_modes::srv::GetMode_Request;
  using Response = system_modes::srv::GetMode_Response;
};

}  // namespace srv

}  // namespace system_modes

#endif  // SYSTEM_MODES__SRV__GET_MODE__STRUCT_HPP_
