#ifndef _H_C3FC8CC17FE3A4F7BC8CDAD6463228BB_ChangeMode_DCPS_H_
#define _H_C3FC8CC17FE3A4F7BC8CDAD6463228BB_ChangeMode_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ChangeMode_.h"


namespace system_modes
{
    namespace srv
    {
        namespace dds_
        {
            class ChangeMode_Request_TypeSupportInterface;

            typedef ChangeMode_Request_TypeSupportInterface * ChangeMode_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Request_TypeSupportInterface> ChangeMode_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Request_TypeSupportInterface> ChangeMode_Request_TypeSupportInterface_out;


            class ChangeMode_Request_DataWriter;

            typedef ChangeMode_Request_DataWriter * ChangeMode_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Request_DataWriter> ChangeMode_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Request_DataWriter> ChangeMode_Request_DataWriter_out;


            class ChangeMode_Request_DataReader;

            typedef ChangeMode_Request_DataReader * ChangeMode_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Request_DataReader> ChangeMode_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Request_DataReader> ChangeMode_Request_DataReader_out;


            class ChangeMode_Request_DataReaderView;

            typedef ChangeMode_Request_DataReaderView * ChangeMode_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Request_DataReaderView> ChangeMode_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Request_DataReaderView> ChangeMode_Request_DataReaderView_out;

            struct ChangeMode_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ChangeMode_Request_, struct ChangeMode_Request_Seq_uniq_> ChangeMode_Request_Seq;
            typedef DDS_DCPSSequence_var < ChangeMode_Request_Seq> ChangeMode_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ChangeMode_Request_Seq> ChangeMode_Request_Seq_out;

            class  ChangeMode_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ChangeMode_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ChangeMode_Request_TypeSupportInterface_var _var_type;

                static ChangeMode_Request_TypeSupportInterface_ptr _duplicate (ChangeMode_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ChangeMode_Request_TypeSupportInterface () {};
                ~ChangeMode_Request_TypeSupportInterface () {};
            private:
                ChangeMode_Request_TypeSupportInterface (const ChangeMode_Request_TypeSupportInterface &);
                ChangeMode_Request_TypeSupportInterface & operator = (const ChangeMode_Request_TypeSupportInterface &);
            };

            class  ChangeMode_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ChangeMode_Request_DataWriter_ptr _ptr_type;
                typedef ChangeMode_Request_DataWriter_var _var_type;

                static ChangeMode_Request_DataWriter_ptr _duplicate (ChangeMode_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ChangeMode_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ChangeMode_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Request_& instance_data) = 0;

            protected:
                ChangeMode_Request_DataWriter () {};
                ~ChangeMode_Request_DataWriter () {};
            private:
                ChangeMode_Request_DataWriter (const ChangeMode_Request_DataWriter &);
                ChangeMode_Request_DataWriter & operator = (const ChangeMode_Request_DataWriter &);
            };

            class  ChangeMode_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ChangeMode_Request_DataReader_ptr _ptr_type;
                typedef ChangeMode_Request_DataReader_var _var_type;

                static ChangeMode_Request_DataReader_ptr _duplicate (ChangeMode_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Request_& instance) = 0;

            protected:
                ChangeMode_Request_DataReader () {};
                ~ChangeMode_Request_DataReader () {};
            private:
                ChangeMode_Request_DataReader (const ChangeMode_Request_DataReader &);
                ChangeMode_Request_DataReader & operator = (const ChangeMode_Request_DataReader &);
            };

            class  ChangeMode_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ChangeMode_Request_DataReaderView_ptr _ptr_type;
                typedef ChangeMode_Request_DataReaderView_var _var_type;

                static ChangeMode_Request_DataReaderView_ptr _duplicate (ChangeMode_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Request_& instance) = 0;

            protected:
                ChangeMode_Request_DataReaderView () {};
                ~ChangeMode_Request_DataReaderView () {};
            private:
                ChangeMode_Request_DataReaderView (const ChangeMode_Request_DataReaderView &);
                ChangeMode_Request_DataReaderView & operator = (const ChangeMode_Request_DataReaderView &);
            };
            class ChangeMode_Response_TypeSupportInterface;

            typedef ChangeMode_Response_TypeSupportInterface * ChangeMode_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Response_TypeSupportInterface> ChangeMode_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Response_TypeSupportInterface> ChangeMode_Response_TypeSupportInterface_out;


            class ChangeMode_Response_DataWriter;

            typedef ChangeMode_Response_DataWriter * ChangeMode_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Response_DataWriter> ChangeMode_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Response_DataWriter> ChangeMode_Response_DataWriter_out;


            class ChangeMode_Response_DataReader;

            typedef ChangeMode_Response_DataReader * ChangeMode_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Response_DataReader> ChangeMode_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Response_DataReader> ChangeMode_Response_DataReader_out;


            class ChangeMode_Response_DataReaderView;

            typedef ChangeMode_Response_DataReaderView * ChangeMode_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ChangeMode_Response_DataReaderView> ChangeMode_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ChangeMode_Response_DataReaderView> ChangeMode_Response_DataReaderView_out;

            struct ChangeMode_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ChangeMode_Response_, struct ChangeMode_Response_Seq_uniq_> ChangeMode_Response_Seq;
            typedef DDS_DCPSSequence_var < ChangeMode_Response_Seq> ChangeMode_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ChangeMode_Response_Seq> ChangeMode_Response_Seq_out;

            class  ChangeMode_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ChangeMode_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ChangeMode_Response_TypeSupportInterface_var _var_type;

                static ChangeMode_Response_TypeSupportInterface_ptr _duplicate (ChangeMode_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ChangeMode_Response_TypeSupportInterface () {};
                ~ChangeMode_Response_TypeSupportInterface () {};
            private:
                ChangeMode_Response_TypeSupportInterface (const ChangeMode_Response_TypeSupportInterface &);
                ChangeMode_Response_TypeSupportInterface & operator = (const ChangeMode_Response_TypeSupportInterface &);
            };

            class  ChangeMode_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ChangeMode_Response_DataWriter_ptr _ptr_type;
                typedef ChangeMode_Response_DataWriter_var _var_type;

                static ChangeMode_Response_DataWriter_ptr _duplicate (ChangeMode_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ChangeMode_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ChangeMode_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Response_& instance_data) = 0;

            protected:
                ChangeMode_Response_DataWriter () {};
                ~ChangeMode_Response_DataWriter () {};
            private:
                ChangeMode_Response_DataWriter (const ChangeMode_Response_DataWriter &);
                ChangeMode_Response_DataWriter & operator = (const ChangeMode_Response_DataWriter &);
            };

            class  ChangeMode_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ChangeMode_Response_DataReader_ptr _ptr_type;
                typedef ChangeMode_Response_DataReader_var _var_type;

                static ChangeMode_Response_DataReader_ptr _duplicate (ChangeMode_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Response_& instance) = 0;

            protected:
                ChangeMode_Response_DataReader () {};
                ~ChangeMode_Response_DataReader () {};
            private:
                ChangeMode_Response_DataReader (const ChangeMode_Response_DataReader &);
                ChangeMode_Response_DataReader & operator = (const ChangeMode_Response_DataReader &);
            };

            class  ChangeMode_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ChangeMode_Response_DataReaderView_ptr _ptr_type;
                typedef ChangeMode_Response_DataReaderView_var _var_type;

                static ChangeMode_Response_DataReaderView_ptr _duplicate (ChangeMode_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ChangeMode_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ChangeMode_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ChangeMode_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ChangeMode_Response_& instance) = 0;

            protected:
                ChangeMode_Response_DataReaderView () {};
                ~ChangeMode_Response_DataReaderView () {};
            private:
                ChangeMode_Response_DataReaderView (const ChangeMode_Response_DataReaderView &);
                ChangeMode_Response_DataReaderView & operator = (const ChangeMode_Response_DataReaderView &);
            };
            class Sample_ChangeMode_Request_TypeSupportInterface;

            typedef Sample_ChangeMode_Request_TypeSupportInterface * Sample_ChangeMode_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Request_TypeSupportInterface> Sample_ChangeMode_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Request_TypeSupportInterface> Sample_ChangeMode_Request_TypeSupportInterface_out;


            class Sample_ChangeMode_Request_DataWriter;

            typedef Sample_ChangeMode_Request_DataWriter * Sample_ChangeMode_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Request_DataWriter> Sample_ChangeMode_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Request_DataWriter> Sample_ChangeMode_Request_DataWriter_out;


            class Sample_ChangeMode_Request_DataReader;

            typedef Sample_ChangeMode_Request_DataReader * Sample_ChangeMode_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Request_DataReader> Sample_ChangeMode_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Request_DataReader> Sample_ChangeMode_Request_DataReader_out;


            class Sample_ChangeMode_Request_DataReaderView;

            typedef Sample_ChangeMode_Request_DataReaderView * Sample_ChangeMode_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Request_DataReaderView> Sample_ChangeMode_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Request_DataReaderView> Sample_ChangeMode_Request_DataReaderView_out;

            struct Sample_ChangeMode_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ChangeMode_Request_, struct Sample_ChangeMode_Request_Seq_uniq_> Sample_ChangeMode_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ChangeMode_Request_Seq> Sample_ChangeMode_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ChangeMode_Request_Seq> Sample_ChangeMode_Request_Seq_out;

            class  Sample_ChangeMode_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ChangeMode_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ChangeMode_Request_TypeSupportInterface_var _var_type;

                static Sample_ChangeMode_Request_TypeSupportInterface_ptr _duplicate (Sample_ChangeMode_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ChangeMode_Request_TypeSupportInterface () {};
                ~Sample_ChangeMode_Request_TypeSupportInterface () {};
            private:
                Sample_ChangeMode_Request_TypeSupportInterface (const Sample_ChangeMode_Request_TypeSupportInterface &);
                Sample_ChangeMode_Request_TypeSupportInterface & operator = (const Sample_ChangeMode_Request_TypeSupportInterface &);
            };

            class  Sample_ChangeMode_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ChangeMode_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ChangeMode_Request_DataWriter_var _var_type;

                static Sample_ChangeMode_Request_DataWriter_ptr _duplicate (Sample_ChangeMode_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ChangeMode_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ChangeMode_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ChangeMode_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Request_& instance_data) = 0;

            protected:
                Sample_ChangeMode_Request_DataWriter () {};
                ~Sample_ChangeMode_Request_DataWriter () {};
            private:
                Sample_ChangeMode_Request_DataWriter (const Sample_ChangeMode_Request_DataWriter &);
                Sample_ChangeMode_Request_DataWriter & operator = (const Sample_ChangeMode_Request_DataWriter &);
            };

            class  Sample_ChangeMode_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ChangeMode_Request_DataReader_ptr _ptr_type;
                typedef Sample_ChangeMode_Request_DataReader_var _var_type;

                static Sample_ChangeMode_Request_DataReader_ptr _duplicate (Sample_ChangeMode_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Request_& instance) = 0;

            protected:
                Sample_ChangeMode_Request_DataReader () {};
                ~Sample_ChangeMode_Request_DataReader () {};
            private:
                Sample_ChangeMode_Request_DataReader (const Sample_ChangeMode_Request_DataReader &);
                Sample_ChangeMode_Request_DataReader & operator = (const Sample_ChangeMode_Request_DataReader &);
            };

            class  Sample_ChangeMode_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ChangeMode_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ChangeMode_Request_DataReaderView_var _var_type;

                static Sample_ChangeMode_Request_DataReaderView_ptr _duplicate (Sample_ChangeMode_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ChangeMode_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ChangeMode_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Request_& instance) = 0;

            protected:
                Sample_ChangeMode_Request_DataReaderView () {};
                ~Sample_ChangeMode_Request_DataReaderView () {};
            private:
                Sample_ChangeMode_Request_DataReaderView (const Sample_ChangeMode_Request_DataReaderView &);
                Sample_ChangeMode_Request_DataReaderView & operator = (const Sample_ChangeMode_Request_DataReaderView &);
            };
            class Sample_ChangeMode_Response_TypeSupportInterface;

            typedef Sample_ChangeMode_Response_TypeSupportInterface * Sample_ChangeMode_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Response_TypeSupportInterface> Sample_ChangeMode_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Response_TypeSupportInterface> Sample_ChangeMode_Response_TypeSupportInterface_out;


            class Sample_ChangeMode_Response_DataWriter;

            typedef Sample_ChangeMode_Response_DataWriter * Sample_ChangeMode_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Response_DataWriter> Sample_ChangeMode_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Response_DataWriter> Sample_ChangeMode_Response_DataWriter_out;


            class Sample_ChangeMode_Response_DataReader;

            typedef Sample_ChangeMode_Response_DataReader * Sample_ChangeMode_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Response_DataReader> Sample_ChangeMode_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Response_DataReader> Sample_ChangeMode_Response_DataReader_out;


            class Sample_ChangeMode_Response_DataReaderView;

            typedef Sample_ChangeMode_Response_DataReaderView * Sample_ChangeMode_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ChangeMode_Response_DataReaderView> Sample_ChangeMode_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ChangeMode_Response_DataReaderView> Sample_ChangeMode_Response_DataReaderView_out;

            struct Sample_ChangeMode_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ChangeMode_Response_, struct Sample_ChangeMode_Response_Seq_uniq_> Sample_ChangeMode_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ChangeMode_Response_Seq> Sample_ChangeMode_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ChangeMode_Response_Seq> Sample_ChangeMode_Response_Seq_out;

            class  Sample_ChangeMode_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ChangeMode_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ChangeMode_Response_TypeSupportInterface_var _var_type;

                static Sample_ChangeMode_Response_TypeSupportInterface_ptr _duplicate (Sample_ChangeMode_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ChangeMode_Response_TypeSupportInterface () {};
                ~Sample_ChangeMode_Response_TypeSupportInterface () {};
            private:
                Sample_ChangeMode_Response_TypeSupportInterface (const Sample_ChangeMode_Response_TypeSupportInterface &);
                Sample_ChangeMode_Response_TypeSupportInterface & operator = (const Sample_ChangeMode_Response_TypeSupportInterface &);
            };

            class  Sample_ChangeMode_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ChangeMode_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ChangeMode_Response_DataWriter_var _var_type;

                static Sample_ChangeMode_Response_DataWriter_ptr _duplicate (Sample_ChangeMode_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ChangeMode_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ChangeMode_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ChangeMode_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Response_& instance_data) = 0;

            protected:
                Sample_ChangeMode_Response_DataWriter () {};
                ~Sample_ChangeMode_Response_DataWriter () {};
            private:
                Sample_ChangeMode_Response_DataWriter (const Sample_ChangeMode_Response_DataWriter &);
                Sample_ChangeMode_Response_DataWriter & operator = (const Sample_ChangeMode_Response_DataWriter &);
            };

            class  Sample_ChangeMode_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ChangeMode_Response_DataReader_ptr _ptr_type;
                typedef Sample_ChangeMode_Response_DataReader_var _var_type;

                static Sample_ChangeMode_Response_DataReader_ptr _duplicate (Sample_ChangeMode_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Response_& instance) = 0;

            protected:
                Sample_ChangeMode_Response_DataReader () {};
                ~Sample_ChangeMode_Response_DataReader () {};
            private:
                Sample_ChangeMode_Response_DataReader (const Sample_ChangeMode_Response_DataReader &);
                Sample_ChangeMode_Response_DataReader & operator = (const Sample_ChangeMode_Response_DataReader &);
            };

            class  Sample_ChangeMode_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ChangeMode_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ChangeMode_Response_DataReaderView_var _var_type;

                static Sample_ChangeMode_Response_DataReaderView_ptr _duplicate (Sample_ChangeMode_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ChangeMode_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ChangeMode_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ChangeMode_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ChangeMode_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ChangeMode_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ChangeMode_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ChangeMode_Response_& instance) = 0;

            protected:
                Sample_ChangeMode_Response_DataReaderView () {};
                ~Sample_ChangeMode_Response_DataReaderView () {};
            private:
                Sample_ChangeMode_Response_DataReaderView (const Sample_ChangeMode_Response_DataReaderView &);
                Sample_ChangeMode_Response_DataReaderView & operator = (const Sample_ChangeMode_Response_DataReaderView &);
            };
        }

    }

}

#endif
