// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from system_modes:srv/GetAvailableModes.idl
// generated code does not contain a copyright notice
#include "system_modes/srv/get_available_modes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `node_name`
#include "rosidl_generator_c/string_functions.h"

bool
system_modes__srv__GetAvailableModes_Request__init(system_modes__srv__GetAvailableModes_Request * msg)
{
  if (!msg) {
    return false;
  }
  // node_name
  if (!rosidl_generator_c__String__init(&msg->node_name)) {
    system_modes__srv__GetAvailableModes_Request__fini(msg);
    return false;
  }
  return true;
}

void
system_modes__srv__GetAvailableModes_Request__fini(system_modes__srv__GetAvailableModes_Request * msg)
{
  if (!msg) {
    return;
  }
  // node_name
  rosidl_generator_c__String__fini(&msg->node_name);
}

system_modes__srv__GetAvailableModes_Request *
system_modes__srv__GetAvailableModes_Request__create()
{
  system_modes__srv__GetAvailableModes_Request * msg = (system_modes__srv__GetAvailableModes_Request *)malloc(sizeof(system_modes__srv__GetAvailableModes_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes__srv__GetAvailableModes_Request));
  bool success = system_modes__srv__GetAvailableModes_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
system_modes__srv__GetAvailableModes_Request__destroy(system_modes__srv__GetAvailableModes_Request * msg)
{
  if (msg) {
    system_modes__srv__GetAvailableModes_Request__fini(msg);
  }
  free(msg);
}


bool
system_modes__srv__GetAvailableModes_Request__Sequence__init(system_modes__srv__GetAvailableModes_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  system_modes__srv__GetAvailableModes_Request * data = NULL;
  if (size) {
    data = (system_modes__srv__GetAvailableModes_Request *)calloc(size, sizeof(system_modes__srv__GetAvailableModes_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes__srv__GetAvailableModes_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes__srv__GetAvailableModes_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes__srv__GetAvailableModes_Request__Sequence__fini(system_modes__srv__GetAvailableModes_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes__srv__GetAvailableModes_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes__srv__GetAvailableModes_Request__Sequence *
system_modes__srv__GetAvailableModes_Request__Sequence__create(size_t size)
{
  system_modes__srv__GetAvailableModes_Request__Sequence * array = (system_modes__srv__GetAvailableModes_Request__Sequence *)malloc(sizeof(system_modes__srv__GetAvailableModes_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = system_modes__srv__GetAvailableModes_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
system_modes__srv__GetAvailableModes_Request__Sequence__destroy(system_modes__srv__GetAvailableModes_Request__Sequence * array)
{
  if (array) {
    system_modes__srv__GetAvailableModes_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `available_modes`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
system_modes__srv__GetAvailableModes_Response__init(system_modes__srv__GetAvailableModes_Response * msg)
{
  if (!msg) {
    return false;
  }
  // available_modes
  if (!rosidl_generator_c__String__Sequence__init(&msg->available_modes, 0)) {
    system_modes__srv__GetAvailableModes_Response__fini(msg);
    return false;
  }
  return true;
}

void
system_modes__srv__GetAvailableModes_Response__fini(system_modes__srv__GetAvailableModes_Response * msg)
{
  if (!msg) {
    return;
  }
  // available_modes
  rosidl_generator_c__String__Sequence__fini(&msg->available_modes);
}

system_modes__srv__GetAvailableModes_Response *
system_modes__srv__GetAvailableModes_Response__create()
{
  system_modes__srv__GetAvailableModes_Response * msg = (system_modes__srv__GetAvailableModes_Response *)malloc(sizeof(system_modes__srv__GetAvailableModes_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(system_modes__srv__GetAvailableModes_Response));
  bool success = system_modes__srv__GetAvailableModes_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
system_modes__srv__GetAvailableModes_Response__destroy(system_modes__srv__GetAvailableModes_Response * msg)
{
  if (msg) {
    system_modes__srv__GetAvailableModes_Response__fini(msg);
  }
  free(msg);
}


bool
system_modes__srv__GetAvailableModes_Response__Sequence__init(system_modes__srv__GetAvailableModes_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  system_modes__srv__GetAvailableModes_Response * data = NULL;
  if (size) {
    data = (system_modes__srv__GetAvailableModes_Response *)calloc(size, sizeof(system_modes__srv__GetAvailableModes_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = system_modes__srv__GetAvailableModes_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        system_modes__srv__GetAvailableModes_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
system_modes__srv__GetAvailableModes_Response__Sequence__fini(system_modes__srv__GetAvailableModes_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      system_modes__srv__GetAvailableModes_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

system_modes__srv__GetAvailableModes_Response__Sequence *
system_modes__srv__GetAvailableModes_Response__Sequence__create(size_t size)
{
  system_modes__srv__GetAvailableModes_Response__Sequence * array = (system_modes__srv__GetAvailableModes_Response__Sequence *)malloc(sizeof(system_modes__srv__GetAvailableModes_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = system_modes__srv__GetAvailableModes_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
system_modes__srv__GetAvailableModes_Response__Sequence__destroy(system_modes__srv__GetAvailableModes_Response__Sequence * array)
{
  if (array) {
    system_modes__srv__GetAvailableModes_Response__Sequence__fini(array);
  }
  free(array);
}
